
***********************************************************************
*
***********************************************************************
DEFINE CLASS _bmp AS CUSTOM
*!*	   PROTECTED biSize,Size,Head,Offset,Reserved1,Reserved2,biSize,;
*!*	             biWidth,biHeight,biPlanes,biBitCount,biCompression,biSizeImage,;
*!*	             biXPelsPerMeter,biYPelsPerMeter,biClrUsed,biClrImportant,;
*!*	             ColorArray,Data,_Index,_ByteCount

   Head=""
   Size=0
   Offset=0
   Reserved1=0
   Reserved2=0

   biSize=0 && DWORD  biSize
   biWidth=0 && LONG   biWidth 
   biHeight=0 &&  LONG   biHeight
   biPlanes=0 &&  WORD   biPlanes 
   biBitCount=0 &&  WORD   biBitCount
   biCompression=0 &&  DWORD  biCompression
   biSizeImage=0 &&  DWORD  biSizeImage
   biXPelsPerMeter=0 &&  LONG   biXPelsPerMeter
   biYPelsPerMeter=0 &&  LONG   biYPelsPerMeter
   biClrUsed=0 &&  DWORD  biClrUsed
   biClrImportant=0 &&  DWORD  biClrImportant
   _ByteCount=0 && bytecount per biBitCount

   ColorArray=""
   Data=""

   _Index=-1
   _Delta=0

   PROCEDURE C2RGB(liColor,laColor)
      LOCAL lcPom
      lcPom=RIGHT(TRANSFORM(m.liColor,"@0"),6)
      laColor(1)=VAL("0x"+RIGHT(m.lcPom,2))
      laColor(2)=VAL("0x"+SUBST(m.lcPom,3,2))
      laColor(3)=VAL("0x"+LEFT(m.lcPom,2))
   ENDPROC   

   PROCEDURE ReadFromFile(lcFile)
      LOCAL lcPom,liStart
      lcPom=FILETOSTR(m.lcFile)

      *BITMAPFILEHEADER
      This.Head=SUBST(m.lcPom,1,2)
      This.Size=CTOBIN(SUBST(m.lcPom,3,4),"RS") && kompletn velikost BMP souboru
      This.Reserved1=CTOBIN(SUBST(m.lcPom,7,2),"2RS")
      This.Reserved2=CTOBIN(SUBST(m.lcPom,9,2),"2RS")
      This.Offset=CTOBIN(SUBST(m.lcPom,11,4),"RS") && Specifies the offset, in bytes, from the beginning of 
                         && the BITMAPFILEHEADER structure to the bitmap bits. 

      *BITMAPINFOHEADER
      This.biSize=CTOBIN(SUBST(m.lcPom,15,4),"RS") && DWORD  biSize
      This.biWidth=CTOBIN(SUBST(m.lcPom,19,4),"RS") && LONG   biWidth 
      This.biHeight=CTOBIN(SUBST(m.lcPom,23,4),"RS") &&  LONG   biHeight
      This.biPlanes=CTOBIN(SUBST(m.lcPom,27,2),"RS") &&  WORD   biPlanes 
      This.biBitCount=CTOBIN(SUBST(m.lcPom,29,2),"RS") &&  WORD   biBitCount
      This.biCompression=CTOBIN(SUBST(m.lcPom,31,4),"RS") &&  DWORD  biCompression
      This.biSizeImage=CTOBIN(SUBST(m.lcPom,35,4),"RS") &&  DWORD  biSizeImage
      This.biXPelsPerMeter=CTOBIN(SUBST(m.lcPom,39,4),"RS") &&  LONG   biXPelsPerMeter
      This.biYPelsPerMeter=CTOBIN(SUBST(m.lcPom,43,4),"RS") &&  LONG   biYPelsPerMeter
      This.biClrUsed=CTOBIN(SUBST(m.lcPom,47,4),"RS") &&  DWORD  biClrUsed
      This.biClrImportant=CTOBIN(SUBST(m.lcPom,51,4),"RS") &&  DWORD  biClrImportant

      This._Delta=4-This.biWidth%4
      This._Delta=IIF(This._Delta=4,0,This._Delta)
      This._ByteCount=This.biBitCount/8

      * Pole barev
      IF This.biBitCount=8
         This._Index=256
         This.ColorArray=SUBST(m.lcPom,15+This.biSize,This._Index*4)
      ENDIF
      * Data
      This.Data=SUBST(m.lcPom,This.Offset+1)
   ENDPROC

   PROCEDURE GetIndexByColor(liR,liG,liB,liA)
      LOCAL liStart
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liStart=AT(CHR(m.liB)+CHR(m.liG)+CHR(m.liR)+CHR(m.liA),This.ColorArray)
      IF m.liStart=0
         liStart=AT(CHR(m.liB)+CHR(m.liG)+CHR(m.liR),This.ColorArray)
      ENDIF
      RETURN IIF(m.liStart=0,-1,INT((m.liStart-1)/4))
   ENDPROC

   PROCEDURE GetColorByIndex(liIndex)
      LOCAL liStart
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liStart=m.liIndex*4+1
      RETURN RGB(ASC(SUBST(This.ColorArray,m.liStart+2,1)),ASC(SUBST(This.ColorArray,m.liStart+1,1)),ASC(SUBST(This.ColorArray,m.liStart,1)))
   ENDPROC

   PROCEDURE SetColorByIndex(liIndex,liR,liG,liB,liA)
      IF This.biBitCount>8
         RETURN .F.
      ENDIF
      This.ColorArray=STUFF(This.ColorArray,m.liIndex*4+1,4,CHR(m.liB)+CHR(m.liG)+CHR(m.liR)+CHR(m.liA))
   ENDPROC

   PROCEDURE AddColor(liR,liG,liB,liA)
      LOCAL liIndex
      IF This.biBitCount>8
         RETURN -1
      ENDIF
      liIndex=This.GetIndexByColor(m.liR,m.liG,m.liB,m.liA)
      IF liIndex=-1 OR m.liIndex>This._Index
         STORE This._Index+1 TO This._Index,liIndex
         =This.SetColorByIndex(m.liIndex,m.liR,m.liG,m.liB,m.liA)
      ENDIF
      RETURN m.liIndex
   ENDPROC


   PROCEDURE GetPointColor(liY,liX,llIndex)
      LOCAL liLen,lcPom
      liLen=This._ByteCount
      lcPom=SUBSTR(This.Data,(m.liX-1)*m.liLen+1+(This.biHeight-m.liY)*(This.biWidth*m.liLen+This._Delta),m.liLen)

      RETURN IIF(m.liLen>1,;
                 IIF(m.liLen=2,CTOBIN(m.lcPom,"2S"),IIF(m.liLen=3,CTOBIN(CHR(0)+m.lcPom,"S"),CTOBIN(m.lcPom,"S"))),;
                 IIF(m.llIndex,ASC(m.lcPom),This.GetColorByIndex(ASC(m.lcPom))))
   ENDPROC


   PROCEDURE SetPointColor(liY,liX,liIndex,llIndex)
      LOCAL liLen,lcData,lcPom
      liLen=This._ByteCount
      IF m.liLen=1
         lcPom=IIF(!m.llIndex,SUBST(TRANSFORM(m.liIndex,"@0"),3),"")
         lcData=CHR(IIF(m.llIndex,m.liIndex,This.AddColor(VAL("0x"+RIGHT(m.lcPom,2)),VAL("0x"+SUBST(m.lcPom,5,2)),VAL("0x"+SUBST(m.lcPom,3,2)),0)))
      ELSE
         lcData=RIGHT(BINTOC(m.liIndex,"S"),m.liLen)
      ENDIF
      This.Data=STUFF(This.Data,(m.liX-1)*m.liLen+1+(This.biHeight-m.liY)*(This.biWidth*m.liLen+This._Delta)  ,m.liLen, m.lcData )
   ENDPROC


   PROCEDURE RGBToRAWData(liIndex,llIndex)
      LOCAL liLen,lcPom
      liLen=This._ByteCount
      IF m.liLen=1
         lcPom=IIF(!m.llIndex,SUBST(TRANSFORM(m.liIndex,"@0"),3),"")
         RETURN CHR(IIF(m.llIndex,m.liIndex,This.AddColor(VAL("0x"+RIGHT(m.lcPom,2)),VAL("0x"+SUBST(m.lcPom,5,2)),VAL("0x"+SUBST(m.lcPom,3,2)),0)))
      ENDIF
      RETURN RIGHT(BINTOC(m.liIndex,"S"),m.liLen)
   ENDPROC

   PROCEDURE YToDataIndex(liY,liX1)
      RETURN (m.liX1-1)*This._ByteCount+1+(This.biHeight-m.liY)*(This.biWidth*This._ByteCount+This._Delta)
   ENDPROC

   PROCEDURE PutVLine(liY,liX1,liX2,liIndex,llIndex)
      LOCAL liLen,lcData,lcPom
      liLen=This._ByteCount
      IF m.liX2<m.liX1 OR m.liX1<0 OR m.liX2>This.biWidth
         RETURN .F.
      ENDIF
      IF m.liLen=1
         lcPom=IIF(!m.llIndex,SUBST(TRANSFORM(m.liIndex,"@0"),3),"")
         lcData=CHR(IIF(m.llIndex,m.liIndex,This.AddColor(VAL("0x"+RIGHT(m.lcPom,2)),VAL("0x"+SUBST(m.lcPom,5,2)),VAL("0x"+SUBST(m.lcPom,3,2)),0)))
      ELSE
         lcData=RIGHT(BINTOC(m.liIndex,"S"),m.liLen)
      ENDIF
      This.Data=STUFF(This.Data,(m.liX1-1)*m.liLen+1+(This.biHeight-m.liY)*(This.biWidth*m.liLen+This._Delta), m.liLen*(m.liX2-m.liX1+1), REPL(m.lcData,m.liX2-m.liX1+1))
   ENDPROC

   PROCEDURE PutHLine(liX,liY1,liY2,liIndex,llIndex)
      LOCAL liLen,lcData,lii,lcPom
      liLen=This._ByteCount
      IF m.liY2<m.liY1 OR m.liY1<0 OR m.liY2>This.biHeight
         RETURN .F.
      ENDIF
      IF m.liLen=1
         lcPom=IIF(!m.llIndex,SUBST(TRANSFORM(m.liIndex,"@0"),3),"")
         lcData=CHR(IIF(m.llIndex,m.liIndex,This.AddColor(VAL("0x"+RIGHT(m.lcPom,2)),VAL("0x"+SUBST(m.lcPom,5,2)),VAL("0x"+SUBST(m.lcPom,3,2)),0)))
      ELSE
         lcData=RIGHT(BINTOC(m.liIndex,"S"),m.liLen)
      ENDIF

      FOR lii=0 TO m.liY2-m.liY1
          This.Data=STUFF(This.Data,(m.liX-1)*m.liLen+1+(This.biHeight-(m.liY1+m.lii))*(This.biWidth*m.liLen+This._Delta)  ,m.liLen, m.lcData )
      NEXT
   ENDPROC



   PROCEDURE FillSolid(liY1,liY2, liX1,liX2, liColor)
      LOCAL liHeight,liWidth,lii,lir,lig,lib,lnx1,lny1,lnx2,lny2
      liHeight=m.liY2-m.liY1+1
      liWidth=m.liX2-m.liX1+1
      FOR lii=0 TO m.liHeight-1
          This.PutVLine(m.lii+m.liY1,m.liX1,m.liX2,m.liColor,.T.)
      NEXT
   ENDPROC

   PROCEDURE FillGradient(liType, liY1,liY2, liX1,liX2, liColor1,liColor2)
      LOCAL liHeight,liWidth,lii,lir,lig,lib,lnX1,lnY1,lnX2,lnY2,lcData,liLen
      LOCAL ARRAY laColor1(3), laColor2(3),laCache(1)
      =This.C2RGB(m.liColor1,@m.laColor1)
      =This.C2RGB(m.liColor2,@m.laColor2)

      liHeight=m.liY2-m.liY1+1
      liWidth=m.liX2-m.liX1+1
      IF BITTEST(m.liType,0) AND BITTEST(m.liType,1) && oboje
         STORE 0 TO  lnX1,lnY1,lnX2,lnY2
         This.SetPointColor(m.liY1,m.liX1,m.liColor1,.T.)

         DO WHILE (m.lnX1 < m.liWidth AND m.lnY1 < m.liHeight)
            IF m.lnY1 < m.liHeight-1
               lnY1 = m.lnY1 + 1 
            ELSE
               lnX1 = m.lnX1 + 1
            ENDIF

            IF m.lnX2 < m.liWidth-1
               lnX2 = m.lnX2 + 1 
            ELSE
               lnY2 = m.lnY2 + 1 
            ENDIF  

            lii = m.lnX1+m.lnY1
            lir = m.laColor1(1) + (m.lii * (m.laColor2(1)-m.laColor1(1)) / (m.liWidth+m.liHeight))
            lig = m.laColor1(2) + (m.lii * (m.laColor2(2)-m.laColor1(2)) / (m.liWidth+m.liHeight))
            lib = m.laColor1(3) + (m.lii * (m.laColor2(3)-m.laColor1(3)) / (m.liWidth+m.liHeight))
            FOR lii=m.lnY1 TO m.lnY2 STEP -1
                This.SetPointColor(m.liY1+m.lii,m.liX1+m.lnX1+(m.lnY1-m.lii),RGB(m.lir,m.lig,m.lib),.T.)
            NEXT
         ENDDO
      ENDIF 


      IF BITTEST(m.liType,0) AND NOT BITTEST(m.liType,1) && Top to down
         liLen=LEN(This.RGBToRAWData(0,.T.))*m.liWidth
         DIMENSION laCache(m.liHeight)
         FOR lii=0 TO m.liHeight-1
             lir = m.laColor1(1) + (m.lii * (m.laColor2(1)-m.laColor1(1)) / m.liHeight)
             lig = m.laColor1(2) + (m.lii * (m.laColor2(2)-m.laColor1(2)) / m.liHeight)
             lib = m.laColor1(3) + (m.lii * (m.laColor2(3)-m.laColor1(3)) / m.liHeight)
             laCache(m.lii+1)=REPLICATE(This.RGBToRAWData(RGB(m.lir,m.lig,m.lib),.T.),m.liWidth)
         NEXT

         FOR lii=0 TO m.liHeight-1
             This.Data=STUFF(This.Data, This.YToDataIndex(m.lii+m.liY1,@m.liX1),m.liLen, m.laCache(m.lii+1))
         NEXT

      ENDIF

      IF NOT BITTEST(m.liType,0) AND BITTEST(m.liType,1) && Left to Right
         lcData=""
         FOR lii=0 TO m.liWidth-1
             lir = m.laColor1(1) + (m.lii * (m.laColor2(1)-m.laColor1(1)) / m.liWidth)
             lig = m.laColor1(2) + (m.lii * (m.laColor2(2)-m.laColor1(2)) / m.liWidth)
             lib = m.laColor1(3) + (m.lii * (m.laColor2(3)-m.laColor1(3)) / m.liWidth)
             lcData=m.lcData+This.RGBToRAWData(RGB(m.lir,m.lig,m.lib),.T.)
         NEXT

         liLen=LEN(m.lcData)
         FOR lii=0 TO m.liHeight-1
             This.Data=STUFF(This.Data, This.YToDataIndex(m.lii+m.liY1,@m.liX1),m.liLen,m.lcData)
         NEXT
      ENDIF
      
   ENDPROC

   PROCEDURE SetData(lcData)
      This.Data=m.lcData
   ENDPROC

   PROCEDURE GetData()
      RETURN This.Data
   ENDPROC

   PROCEDURE SaveToFile(lcFile)
      LOCAL lihFile,lcPom,liLCA
      lihFile=FCREATE(m.lcFile)
      IF m.lihFile<=0
         RETURN .F.
      ENDIF
      liLCA=0
      * Zapi hlaviku
      =FWRITE(m.lihFile,"BM"+REPL(CHR(0),12))

      *BITMAPINFOHEADER
      lcPom=BINTOC(This.biSize,"RS")+;
            BINTOC(This.biWidth,"RS")+;
            BINTOC(This.biHeight,"RS")+;
            BINTOC(This.biPlanes,"2RS")+;
            BINTOC(This.biBitCount,"2RS")+;
            BINTOC(This.biCompression,"RS")+;
            BINTOC(This.biSizeImage,"RS")+;
            BINTOC(This.biXPelsPerMeter,"RS")+;
            BINTOC(This.biYPelsPerMeter,"RS")+;
            BINTOC(This.biClrUsed,"RS")+;
            BINTOC(This.biClrImportant,"RS")

      =FWRITE(lihFile,m.lcPom)

      IF This.biBitCount=8
         =FWRITE(m.lihFile,This.ColorArray,LEN(This.ColorArray))
         liLCA=LEN(This.ColorArray)
      ENDIF   
      =FWRITE(m.lihFile,This.Data,This.biSizeImage)

      * oprava hlaviky
      =FSEEK(m.lihFile,2) && velikost souboru
      =FWRITE(m.lihFile,BINTOC(14+This.biSize+m.liLCA+This.biSizeImage,"RS"))

      =FSEEK(m.lihFile,10) && offset s daty obrzku
      =FWRITE(m.lihFile,BINTOC(14+This.biSize+m.liLCA,"RS"))
      =FCLOSE(m.lihFile)
   ENDPROC

   PROCEDURE New(liWidth,liHeight,liPallete)
      This.Head="BM"
      This.Reserved1=0
      This.Reserved2=0

      This._Delta=4-m.liWidth%4
      This._Delta=IIF(This._Delta=4,0,This._Delta)

      This.biSize=40 && DWORD  biSize
      This.biWidth=m.liWidth && LONG   biWidth 
      This.biHeight=m.liHeight &&  LONG   biHeight
      This.biPlanes=1 &&  WORD   biPlanes 
      This.biBitCount=m.liPallete &&  WORD   biBitCount
      This.biCompression=0 &&  DWORD  biCompression
      This.biSizeImage=m.liHeight*(m.liWidth+This._Delta)*m.liPallete/8 &&  DWORD  biSizeImage
      This.biXPelsPerMeter=0 &&  LONG   biXPelsPerMeter
      This.biYPelsPerMeter=0 &&  LONG   biYPelsPerMeter
      This.biClrUsed=0 &&  DWORD  biClrUsed
      This.biClrImportant=0 &&  DWORD  biClrImportant
      This._ByteCount=This.biBitCount/8
      
      This.ColorArray=IIF(m.liPallete=8,REPL(CHR(255),(m.liPallete/8*256)*4),"")
      This.Data=REPL(CHR(255),This.biSizeImage)
      This._Index=-1
      This.Offset=14+This.biSize+LEN(This.ColorArray)
      This.Size=This.Offset+This.biSizeImage
   ENDPROC

ENDDEFINE


